#!/bin/sh
#
# do_test_nas.sh - NAS side test script for splice_test
#
#	Copyright (c)2013 NETGEAR
#	hsugawara@netgear.com

# Listen on a TCP socket and execute the passed command lines until a null
# command is detected.

##vopt=1
if ! which nc >/dev/null 2>&1
then
	apt-get install netcat-openbsd
fi

[ "$PORT" ] || PORT=8000

while true
do
	cmd=`nc -l $PORT`
	[ "$cmd" ] || exit 0
	if echo "$cmd" | grep -q '^@'
	then
		hp=`echo "$cmd" | cut -d ' ' -f 1`
		host=`echo $hp | sed 's|^@||;s|:.*$||'`
		port=`echo $hp | sed 's|^.*:||'`
		cmd="`echo "$cmd" | cut -d ' ' -f 2-`"

		[ "$vopt" ] && echo "ask: $cmd"

		until eval "$cmd" | nc $host $port
		do
			sleep 0.1
		done
	else
		if [ "$vopt" ]
		then
			echo $cmd | grep -q '^echo' || echo ">> $cmd"
		fi
		$cmd
		if [ "$?" != 0 ]
		then
			echo "*** FAILED ***"
		fi
	fi
done
